#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_width1 1
#property indicator_style1 2
#property indicator_color2 Red
#property indicator_width2 1
#property indicator_style2 2
#property indicator_color3 Aqua
#property indicator_width3 1
#property indicator_style3 2
#property indicator_color4 White
#property indicator_width4 1
#property indicator_style4 2
#property indicator_color5 RoyalBlue
#property indicator_width5 1
#property indicator_style5 2

//---- input parameters
extern string MA1="_____________________________";
extern int   MAPeriod1    = 5;
extern ENUM_MA_METHOD   MAMode1      = MODE_EMA;
extern ENUM_APPLIED_PRICE   MAPrice1     = PRICE_CLOSE;
extern color Price_color1 = Yellow;
extern string MA2="_____________________________";
extern int   MAPeriod2    = 13;
extern ENUM_MA_METHOD   MAMode2      = MODE_EMA;
extern ENUM_APPLIED_PRICE   MAPrice2     = PRICE_CLOSE;
extern color Price_color2 = Red;
extern string MA3="_____________________________";
extern int   MAPeriod3    = 50;
extern ENUM_MA_METHOD   MAMode3      = MODE_EMA;
extern ENUM_APPLIED_PRICE   MAPrice3     = PRICE_CLOSE;
extern color Price_color3 = Aqua;
extern string MA4="_____________________________";
extern int   MAPeriod4    = 200;
extern ENUM_MA_METHOD   MAMode4      = MODE_EMA;
extern ENUM_APPLIED_PRICE   MAPrice4     = PRICE_CLOSE;
extern color Price_color4 = White;
extern string MA5="_____________________________";
extern int   MAPeriod5    = 800;
extern ENUM_MA_METHOD   MAMode5      = MODE_EMA;
extern ENUM_APPLIED_PRICE   MAPrice5     = PRICE_CLOSE;
extern color Price_color5 = RoyalBlue;
extern string Price__________________="_____________________________";
extern int   Price_Size  = 1;
extern int   Shift_Price = 5;
input ENUM_LINE_STYLE Line_Style = STYLE_DOT;
input int Line_Width  = 1;

extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "MAs";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                            
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "MAs OFF";            
extern string             btn_unpressed         = "MAs ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 850;                                 
extern int                button_y              = 0;                                   
extern int                btn_Width             = 75;                                 
extern int                btn_Height            = 20;                                
extern string             soundBT               = "tick.wav";  
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix ,buttonId ;


int triplemagic = 0;


//---- indicator buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer5[];
double Buffer4[];
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   SetIndexDrawBegin(0,MAPeriod1);
   SetIndexBuffer(0,Buffer1);
   SetIndexStyle(0,DRAW_LINE,Line_Style,Line_Width);
   SetIndexLabel(0,"");
   
   SetIndexDrawBegin(0,MAPeriod2);
   SetIndexBuffer(1,Buffer2);
   SetIndexStyle(1,DRAW_LINE,Line_Style,Line_Width);
   SetIndexLabel(1,"");
    
   SetIndexDrawBegin(0,MAPeriod3);
   SetIndexBuffer(2,Buffer3);
   SetIndexStyle(2,DRAW_LINE,Line_Style,Line_Width);
   SetIndexLabel(2,"");
   
   SetIndexDrawBegin(1,MAPeriod4);
   SetIndexBuffer(3,Buffer4);
   SetIndexStyle(3,DRAW_LINE,Line_Style,Line_Width);
   SetIndexLabel(3,"");
   
   SetIndexDrawBegin(2,MAPeriod5);
   SetIndexBuffer(4,Buffer5);
   SetIndexStyle(4,DRAW_LINE,Line_Style,Line_Width);
   SetIndexLabel(4,"");
        IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
      double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
   show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);   
   
 
   return(0);
  }
 
 void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
       ObjectCreate(ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}

 
  int deinit()
  {
   ObjectsDeleteAll(0,"MAs");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   
   
//----
  ObjectDelete("PRICE1"+triplemagic);
  ObjectDelete("PRICE2"+triplemagic);
  ObjectDelete("PRICE3"+triplemagic);
  ObjectDelete("PRICE4"+triplemagic);
  ObjectDelete("PRICE5"+triplemagic);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| 5 X EMA                                          |
//+------------------------------------------------------------------+
 bool recalc = true;
 void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
   if (soundBT!="") PlaySound(soundBT);     
   }
   
  
  
	
}
//
//
//
//

int start()
{

handleButtonClicks();
   recalc = false;
   
   SetIndexStyle(0,DRAW_LINE);
  SetIndexStyle(1,DRAW_LINE);
  SetIndexStyle(2,DRAW_LINE);
  SetIndexStyle(3,DRAW_LINE);
  SetIndexStyle(4,DRAW_LINE);
   start2();
   
  
   
      
   
   if (show_data)
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
     
      }
      else
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
       SetIndexStyle(0,DRAW_NONE);
         SetIndexStyle(1,DRAW_NONE);
        SetIndexStyle(2,DRAW_NONE);
        SetIndexStyle(3,DRAW_NONE);
          SetIndexStyle(4,DRAW_NONE);
        ObjectDelete("PRICE1"+triplemagic);
        ObjectDelete("PRICE2"+triplemagic);
        ObjectDelete("PRICE3"+triplemagic);
        ObjectDelete("PRICE4"+triplemagic);
        ObjectDelete("PRICE5"+triplemagic);  
   
      
   
      //template code     
      }
       return(0);
      }
int start2()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
     
      triplemagic = MAPeriod1+MAPeriod2+MAPeriod3+MAPeriod4+MAPeriod5;
      
      Buffer1[i]=iMA(NULL,0,MAPeriod1,0,MAMode1,MAPrice1,i);
      
      Buffer2[i]=iMA(NULL,0,MAPeriod2,0,MAMode2,MAPrice2,i);
      
      Buffer3[i]=iMA(NULL,0,MAPeriod3,0,MAMode3,MAPrice3,i);
      
      Buffer4[i]=iMA(NULL,0,MAPeriod4,0,MAMode4,MAPrice4,i);
    
      Buffer5[i]=iMA(NULL,0,MAPeriod5,0,MAMode5,MAPrice5,i);
      
      
      
          if (ObjectFind("PRICE1"+triplemagic) != 0){
          ObjectCreate("PRICE1"+triplemagic,OBJ_ARROW,0,customTime(-Shift_Price),Buffer1[0]);
          ObjectSet("PRICE1"+triplemagic,OBJPROP_ARROWCODE,6);
          ObjectSet("PRICE1"+triplemagic,OBJPROP_COLOR,Price_color1);  
          ObjectSet("PRICE1"+triplemagic,OBJPROP_WIDTH,Price_Size);  
           }   else {
          ObjectMove("PRICE1"+triplemagic,0,customTime(-Shift_Price),Buffer1[0]);
          ObjectSet("PRICE1"+triplemagic,OBJPROP_COLOR,Price_color1); }  
          
          if (ObjectFind("PRICE2"+triplemagic) != 0){
          ObjectCreate("PRICE2"+triplemagic,OBJ_ARROW,0,customTime(-Shift_Price),Buffer2[0]);
          ObjectSet("PRICE2"+triplemagic,OBJPROP_ARROWCODE,6);
          ObjectSet("PRICE2"+triplemagic,OBJPROP_COLOR,Price_color2);  
          ObjectSet("PRICE2"+triplemagic,OBJPROP_WIDTH,Price_Size);  
           }   else {
          ObjectMove("PRICE2"+triplemagic,0,customTime(-Shift_Price),Buffer2[0]);
          ObjectSet("PRICE2"+triplemagic,OBJPROP_COLOR,Price_color2); }       
       
         if (ObjectFind("PRICE3"+triplemagic) != 0){
          ObjectCreate("PRICE3"+triplemagic,OBJ_ARROW,0,customTime(-Shift_Price),Buffer3[0]);
          ObjectSet("PRICE3"+triplemagic,OBJPROP_ARROWCODE,6);
          ObjectSet("PRICE3"+triplemagic,OBJPROP_COLOR,Price_color3);  
          ObjectSet("PRICE3"+triplemagic,OBJPROP_WIDTH,Price_Size);  
           }   else {
          ObjectMove("PRICE3"+triplemagic,0,customTime(-Shift_Price),Buffer3[0]);
          ObjectSet("PRICE3"+triplemagic,OBJPROP_COLOR,Price_color3); }  
          
         if (ObjectFind("PRICE4"+triplemagic) != 0){
          ObjectCreate("PRICE4"+triplemagic,OBJ_ARROW,0,customTime(-Shift_Price),Buffer4[0]);
          ObjectSet("PRICE4"+triplemagic,OBJPROP_ARROWCODE,6);
          ObjectSet("PRICE4"+triplemagic,OBJPROP_COLOR,Price_color4);  
          ObjectSet("PRICE4"+triplemagic,OBJPROP_WIDTH,Price_Size);  
           }   else {
          ObjectMove("PRICE4"+triplemagic,0,customTime(-Shift_Price),Buffer4[0]);
          ObjectSet("PRICE4"+triplemagic,OBJPROP_COLOR,Price_color4); }  
          
         if (ObjectFind("PRICE5"+triplemagic) != 0){
          ObjectCreate("PRICE5"+triplemagic,OBJ_ARROW,0,customTime(-Shift_Price),Buffer5[0]);
          ObjectSet("PRICE5"+triplemagic,OBJPROP_ARROWCODE,6);
          ObjectSet("PRICE5"+triplemagic,OBJPROP_COLOR,Price_color5);  
          ObjectSet("PRICE5"+triplemagic,OBJPROP_WIDTH,Price_Size);  
           }   else {
          ObjectMove("PRICE5"+triplemagic,0,customTime(-Shift_Price),Buffer5[0]);
          ObjectSet("PRICE5"+triplemagic,OBJPROP_COLOR,Price_color5); }  
          
          
          
        }
//---- done
   return(0);
  }
  
    
  int customTime(int a)
{
if(a<0)
return(Time[0]+Period()*60*MathAbs(a));
else return(Time[a]); 
}
//+------------------------------------------------------------------+

